<?php
$dir = dirname(__FILE__);
require_once( "$dir/Pasti.php" );
define( "LIT_NU", 0 );
define( "LIT_DARURI", 1 );
define( "LIT_VASILE", 2 );
define( "LIT_IOAN", 3 );

$ordine_pericope = array( "Utrenie", "Ceasul 1", "Apostol", "Evanghelie", "Ceasul al 3-lea",
	"Înainte de spălare", "După spălare", "Ceasul al 6-lea", "Tedeum", "Ceasul al 9-lea", "Vecernie", "Seara",
	"Evanghelia I", "Evanghelia a II-a", "Evanghelia a III-a", "Evanghelia a IV-a", "Evanghelia a V-a",
	"Evanghelia a VI-a", "Evanghelia a VII-a", "Evanghelia a VIII-a", "Evanghelia a IX-a", "Evanghelia a X-a",
	"Evanghelia a XI-a", "Evanghelia a XII-a" );

class DayDetails
{
	var $title;
	var $subtitle;
	var $special; // Special holiday
	var $Ap;
	var $Ev;
	var $Ev_title;
	var $pericopa;
	var $isHoliday;
	var $voscr;
	var $glas;
	var $extra; // array(title=>pericopa)
    var $patrar;

	function  __construct( $day, $member = FALSE )
	{
		$this->load( $day, $member );
	}

    static function htmlSaints( $text)
    {
        $saints = explode('; ', $text);
        foreach( $saints as $i => $saint){
            if( @$saint[0] == '*'){
                $saints[$i] = "<span class='rom'>" . substr( $saint, 1) . "</span>";
            }
        }
        return implode('; ', $saints);
    }

	function load( $day, $member = FALSE )
	{
		if( !$member || $member == "Ap" || $member == "pericopa" )
		{
			$this->Ap = ltrim( $this->checkRef( @$day[3], "Ap" ), ".");
		}
		if( !$member || $member == "Ev" || $member == "pericopa" )
		{
			$this->Ev = ltrim( $this->checkRef( @$day[4], "Ev" ), ".");
		}
		if( !$member || $member == "title")
		{
			$this->title = DayDetails::htmlSaints( ltrim( @$day[1], "." ));
        }
        if( !$member || $member == "subtitle" || $member == "special")
        {
			$this->subtitle = DayDetails::htmlSaints( ltrim( @$day[2], "." ));
        }
        if( !$member || $member == "Ev_title")
        {
			$this->Ev_title = ltrim( @$day[5] ?: "", "." );
        }
        if( !$member || $member == "pericopa")
        {
			$this->pericopa = $this->getPericopa( $this->Ap, $this->Ev );
		}
        if( !$member || $member == "special"){
            $this->extractSpecialHoliday(  );
        }
		if( !$member || $member == "extra" )
		{
			$n = count( $day );
			if( $n == 7 )
			{
				$text = $this->checkRef( $day[6], "extra" );
				if( is_array( $text ) )
				{
					$this->extra = $text;
					return;
				}
			}
			if( $n >= 7 )
			{
				$this->extra = array();
				for( $i = 6; $i < $n; $i++ )
				{
					$text = ltrim( $day[$i], "." );
					$pos = strpos( $text, ":" );
					if( !$pos){
                        print_r( $day);
                        die("No : in day[$i]");
                    }
					$title = substr( $text, 0, $pos );
					$pericopa = substr( $text, $pos + 2 );
					$this->extra[$title] = $pericopa;
				}
			}
		}
	}

	static function getPericopa( $Ap, $Ev )
	{
		$pericopa = "";
		if( !empty( $Ap ) )
		{
			$pericopa .= "Ap. " . $Ap;
			if( !empty( $Ev ) )
			{
				$pericopa .= "; ";
			}
		}
		if( !empty( $Ev ) )
		{
			$pericopa .= "Ev. " . $Ev;
		}
		return $pericopa;
	}

	function extractSpecialHoliday()
	{
		$pos = strpos( $this->subtitle, '*' );
		if( $pos !== FALSE )
		{
			$stop = strpos( $this->subtitle, ';', $pos );
			if( $stop == FALSE )
			{
				$stop = strlen( $this->subtitle );
			}
			$this->special = substr( $this->subtitle, $pos + 1, $stop - $pos );
			$this->subtitle = str_replace( '*', '', $this->subtitle );
		}
	}

	function getTitle()
	{
		return !empty( $this->title ) ? $this->title : $this->special;
	}

	static function joinMembers( $parte, $details, $holiday, $date = FALSE )
	{
		if( $details )
		{
			$details = get_object_vars( $details );
			$details = $details[$parte];
		}
		if( $holiday )
		{
			$holiday = get_object_vars( $holiday );
			$holiday = $holiday[$parte];
			if( $holiday == $details )
			{
				$holiday = FALSE; // Duplicat
			}
			if( $holiday && $date )
			{
				$holiday = '<a title="Sinaxar" href="sinaxar.php?date=' . $date . '">' . $holiday . '</a>';
			}
		}
		return joinHolidays( $details, $holiday );
	}

	function checkRef( $text, $member )
	{
		$parts = explode( "; ", $text ?: "" );
		for( $i = 0; $i < count( $parts ); $i++ )
		{
			$parts[$i] = $this->parseRef( $parts[$i], $member );
		}
		if( count( $parts ) == 1 )
		{
			return $parts[0]; // May be an array
		}
		else
		{
			return implode( "; ", $parts );
		}
	}

	function parseRef( $text, $member )
	{
		if( @$text[0] != "@" )
		{
			return $text; // No ref
		}
		$key = substr( $text, 1 );
		$details = getDetails( $key, FALSE, $member );
		assert( $details );
		$vars = get_object_vars( $details );
		return $vars[$member];
	}

	function buildPericope()
	{
		if( $this->voscr )
		{
			$voscr = getVoscr( $this->voscr );
			$this->extra["Utrenie"] = $voscr;
		}
		if( $this->Ap )
		{
			$this->extra["Apostol"] = $this->Ap;
		}
		if( $this->Ev )
		{
			$this->extra["Evanghelie"] = $this->Ev;
		}
	}
}

function sortPericope( $title1, $title2 )
{
	global $ordine_pericope;
	return array_search( $title1, $ordine_pericope ) - array_search( $title2, $ordine_pericope );
}

function joinHolidays( $details, $holiday )
{
	if( $holiday == $details )
	{
		$holiday = FALSE; // Duplicat
	}
	return $details . ($details && $holiday ? "; " : FALSE) . $holiday;
}

function joinExtra( $extra1, $extra2 )
{
	if( empty( $extra1 ) )
	{
		$extra = $extra2;
	}
	elseif( empty( $extra2 ) )
	{
		$extra = $extra1;
	}
	else
	{
		$extra = array();
		foreach( $extra1 as $key => $value )
		{
			if( array_key_exists($key, $extra2) )
			{
				$extra[$key] = joinHolidays( $value, $extra2[$key] );
			}
			else
			{
				$extra[$key] = $value;
			}
		}
		foreach( $extra2 as $key => $value )
		{
			if( !array_key_exists($key, $extra1) )
			{
				$extra[$key] = $value;
			}
		}
	}
	uksort( $extra, 'sortPericope');
	return $extra;
}

function getDetails( $key, $Easter = FALSE, $member = FALSE )
{
	$pos = strpos( $key, "-", 1 );
	if( $pos != FALSE )
	{
		$date = strtotime( "2007-" . $key );
		$zi = getdate( $date );
		$details = getHolidayDetails( $zi, $Easter, $member );
	}
	else
	{
		$details = getDayDetails( $key, $Easter, $member );
	}
	return $details;
}

function getLangFile( $name){
    global $lang;

    $dir = dirname(__FILE__);
    $name = "$dir/../date/$name";
    if( $lang != 'ro'){
        $pos = strrpos( $name,'.');
        $newName = substr( $name, 0, $pos) . "_$lang" . substr( $name, $pos);
        if( file_exists( $newName)){
            $name = $newName;
        }
    }
    return $name;
}

/*
IN: $week - week difference from Easter
OUT: DayDetails or FALSE
*/
function getDayDetails( $week, $Easter = FALSE, $member = FALSE, $zi = NULL )
{
	if( $week === FALSE )
	{
		return FALSE; // Not a Sunday or Easter-related holiday
	}

    if( $zi){
        if( $zi['mon'] == 8 && $zi['mday'] == 6){ // Pobrejenie
            return false;
        }
    }

    $name = getLangFile("duminici.csv");
	$file = fopen( $name, "rt" );
    if( !$file){
        die("Cannot read $name");
    }
	while( ( $day = fgetcsv( $file, 768, "|") ) !== FALSE )
	{
		if( $day[0] == (string)$week )
		{
			break;
		}
	}
	fclose( $file );
	if( $day !== FALSE )
	{
		$details = new DayDetails( $day, $member );
		checkSfAp( $week, $details, $Easter );
        if( $zi){
            checkBV( $zi, $week, $details, $Easter );
            checkSfPr( $zi, $week, $details, $Easter );
        }
		$details->buildPericope();
		$day = $details;
	}
	return $day;
}

/*
IN: $zi - day map
OUT: DayDetails or FALSE
*/
function getHolidayDetails( $zi, $Easter = FALSE, $member = FALSE )
{
    $year = $zi["year"];
    if( !$Easter )
    {
        $Easter = getEasterDate( $year );
    }
    $EasterDay = $Easter["yday"];
    $yday = $zi["yday"];
    $mday = $zi["mday"];
    $month = $zi["mon"];
    // nicio alta sarbatoare de:
    if( $yday == $EasterDay - 7 // Florii
        || $yday == $EasterDay // Pasti
        || $yday == $EasterDay + 49 // Rusalii
        || $yday == $EasterDay + 50 // Sf. Treime
    ){
        return FALSE;
    }

    $name = getLangFile("sfinti_$month.csv");
	$file = fopen( $name, "rt" );
    if( !$file){
        die("Cannot read $name");
    }

	while( ( $day = fgetcsv( $file, 768, "|") ) !== FALSE )
	{
		if( $day[0] == $mday )
		{
			break;
		}
	}
	fclose( $file );

	if( $day !== FALSE )
	{
		$details = new DayDetails( $day, $member );
		$details->isHoliday = TRUE;
		checkLeap( $zi, $details, $Easter );
		checkPomenire( $zi, $details );
		checkPost( $zi, $details );
		calcVoscrGlas( $zi, $details, $Easter );
		$details->buildPericope();
		$day = $details;
        if( $member !== 0 && $mday == 23 && $month == 4 && $yday >= $EasterDay - 7 && $yday <= $EasterDay){ // Sf. Gheorghe cade in Saptamana Mare
            $day->title = false; // se sarbatoreste a doua zi de Pasti
        }

        if( $yday == $EasterDay + 1 && ($month == 4 && $mday >= 24 || $month == 5 && $mday <= 1)){ // Sf. Gheorghe a cazut in Saptamana Mare
            $day->title .= getHolidayDetails( getdate( mktime( 0, 0, 0, 4, 23)), $Easter, 0)->title;
        }

        $moonPhase = getMoonPhase($zi);
        $moonQuarter = $moonPhase * 4;
        if ($moonQuarter - floor($moonQuarter) < 0.14) {
            $patrar = (int)$moonQuarter;
            $day->patrar = "<img src='imagini/luna-$patrar.png' height='16' />";
        }
	}

	return $day;
}

/*
IN: $voscr - Voscreasna (1-11)
OUT: Pericopa voscreasnei
*/
function getVoscr( $voscr )
{
	assert( $voscr >= 0 && $voscr <= 11 );
	if( !$voscr )
	{
		return FALSE; // No voscr
	}

    $dir = dirname(__FILE__);
	$file = fopen( "$dir/../date/voscr.csv", "r" );
	while( ( $day = fgetcsv( $file, 32, "|") ) !== FALSE )
	{
		if( $day[0] == (string)$voscr )
		{
			break;
		}
	}
	fclose( $file );
	if( $day !== FALSE )
	{
		return $day[1];
	}
	return $day;
}

/*
IN: $week - from Easter
$zi - day map
OUT: LIT_*
*/
function getLiturghia( $week, $zi )
{
	if( $week === -53 || // Miercurea alba
		$week === -51 || // Vinerea alba
		$week === -48 || // Prima zi din Postul Mare
		$week === -47 || // A doua zi din Postul Mare
		$week === -2 || // Vinerea Mare
		$zi["wday"] == 5 && ( // Vinerea dinaintea Ajunului
			$zi["mon"] == 1 && // Bobotezei
				( $zi["mday"] == 3 || $zi["mday"] == 4 ) ||
			$zi["mon"] == 12 && // sau Craciunului
				( $zi["mday"] == 22 || $zi["mday"] == 23 ) // daca Ajunul cade sambata sau duminica
		)
	)
	{
		return LIT_NU;
	}

	if( $week == -3 || // Joia Mare
		$week == -1 || // Sambata Mare
		$zi["yday"] == 0 ) // Sf. Vasile cel Mare
	{
		return LIT_VASILE;
	}

	if( $week >= -48 && $week <= -1 ) // Postul Mare
	{

		switch( $zi["wday"] )
		{
			case 6: // sambata
				return LIT_IOAN;

			case 0: // duminica
				return $week !== -7 ? LIT_VASILE : LIT_IOAN; // Florii

			default: // In timpul saptamanii
			{
				return $zi["mon"] == 3 && $zi["mday"] == 25 ? LIT_IOAN : LIT_DARURI; // Blagovestenie
			}
		}
	}

	if( $zi["wday"] == 0 || $zi["wday"] == 1 ) // daca cade duminica sau luni
	{
		if( $zi["mon"] == 12 && $zi["mday"] == 25 // Craciunul
			|| $zi["yday"] == 5 ) // Boboteaza
		{
			return LIT_VASILE;
		}
	}

	if( $zi["wday"] != 6 && $zi["wday"] != 0 ) // daca nu cade sambata sau duminica
	{
		if( $zi["mon"] == 12 && $zi["mday"] == 24	// Ajunul Craciunului
			|| $zi["yday"] == 4 ) // Ajunul Bobotezei
		{
			return LIT_VASILE;
		}
	}

	return LIT_IOAN; // in celelalte zile
}

function getLiturghiaName( $week, $zi )
{
	switch( getLiturghia( $week, $zi ) )
	{
        case LIT_IOAN:
            $lit_text = "Liturghia Sf. Ioan Gură de Aur";
            if( $zi['mon'] == 3 && $zi['mday'] == 25 && $zi['wday'] > 0 && $zi['wday'] < 6){ // Buna Vestire in timpul saptamanii
                $lit_text .= " unită cu Vecernia";
            }
            $lit_clasa = "LIT_IOAN";
            break;

        case LIT_VASILE:
            $lit_text = "Liturghia Sf. Vasile cel Mare";
            if( $week == -3 // Joia Mare
                || $week == -1 // Sambata Mare
                || $zi['mon'] == 1 && $zi['mday'] == 5 // Ajunul Bobotezei
                || $zi['mon'] == 12 && $zi['mday'] == 24){ // Ajunul Craciunului
                $lit_text .= " unită cu Vecernia";
            }
            $lit_clasa = "LIT_VASILE";
            break;

        case LIT_DARURI:
            $lit_text = "Liturghia Darurilor mai înainte sfințite, a Sf. Grigorie Dialogul, unită cu Vecernia";
            $lit_clasa = "LIT_DARURI";
            break;

		case LIT_NU:
			$lit_text = "Ceasurile";
			$lit_clasa = "LIT_NU";
			break;
	}
	return "<span class='" . $lit_clasa . "'>" . $lit_text . "</span>";
}

function checkSfAp( $week, $details, $Easter )
{
	if( $Easter === FALSE )
	{
		return;
	}
	if( $Easter["mon"] == 5 && $Easter["mday"] >= 2 ) // Daca Pastile cad dupa 2 mai postul incepe la Sf. Treime
	{
		if( $week == 57 || $week == 56 )
		{
			$details->Ev_title = "";
		}
		elseif( $week == 50 || $week == 49 )
		{
			$detailsSfAp = getDayDetails( $week + 7 );
			$details->Ev_title = $detailsSfAp->Ev_title;
		}
	}
}

function checkBV( $zi, $week, $details, $Easter)
{
    if( $Easter === FALSE )
    {
        return;
    }

    if( $week >= -20 && $week <= -14 && $week != -17)
    {
        switch( $week){
            case -20: // luni
            case -19: // marti
                if( $zi['mon'] == 3 && $zi['mday'] == 23){ // BV cade intr-a V-a miercuri/joi din Post => Denia Canonului Mare se muta luni/marti
                    $details->Ev_title = getDayDetails( -18)->Ev_title;
                }
                break;
            case -18: // miercuri
            case -16: // vineri
                if( $zi['mon'] == 3 && ($zi['mday'] == 24 || $zi['mday'] == 25)){ // BV cade intr-a V-a miercuri/joi/vineri/sambata din Post => Denia Canonului Mare/Acatistului MD se muta
                    $details->Ev_title = "";
                }
                break;
            case -15: // sambata
            case -14: // duminica
                if( $zi['mon'] == 3 && $zi['mday'] == 26){ // BV cade intr-a V-a vineri/sambata din Post => Denia Acatistului MD se muta sambata/duminica
                    $details->Ev_title = getDayDetails( -16)->Ev_title;
                }
                break;
        }
    }
}

function checkSfPr( $zi, $week, $details, $Easter )
{
    if( $Easter === FALSE )
    {
        return;
    }

    if( is_numeric($week) && $week % 7 == 0){ // duminica
        if( $zi["mon"] == 7 && $zi["mday"] >= 14 && $zi["mday"] <= 20){ // prima duminica dupa 14 iulie (Calendar Doxologia 2024)
            $details->subtitle = "a Sf. Părinţi de la Sinodul al IV-lea Ecumenic; " . $details->subtitle . "; Rugăciunea lui Iisus";
        } elseif( $zi["mon"] == 10 && $zi["mday"] >= 11 && $zi["mday"] <= 17){ // prima duminica dupa 11 octombrie
            $details->subtitle = "a Sf. Părinţi de la Sinodul al VII-lea Ecumenic; " . $details->subtitle . "; Rugăciunea lui Iisus";
        }
    }
}

function checkLeap( $zi, $details, $Easter )
{
	if( $zi["mon"] == 2 && $zi["mday"] == 28 ) // Daca nu e bisect se adauga si sfintii de pe 29 feb.
	{
		$year = $zi["year"];
		if( !isLeap( $year ) ) // no Feb 29th
		{
			$zi = array("year" => $year, "mon" => 2, "mday" => 29, "yday" => $zi["yday"] + 1, "wday" => ($zi["wday"] + 1) % 7, 0 => $zi[0] + 86400 );
			$detailsLeap = getHolidayDetails( $zi, $Easter );
			$details->subtitle = "$detailsLeap->subtitle; $details->subtitle";
		}
	}
}

function checkPomenire( $zi, $details )
{
    global $ls;
	if (
		$zi["wday"] == 6 &&
		(
			$zi["mon"] == 10 && $zi["mday"] >= 30
			|| $zi["mon"] == 11 && $zi["mday"] < 6
		)
	) // A doua sambata dinaintea Postului Craciunului
	{
		$details->Ev_title = $ls->mosiToamna;
	}
}

function checkPost( $zi, $details )
{
    global $ls;
	$wday = $zi["wday"];
	$mday = $zi["mday"];
	$mon = $zi["mon"];

	$ajun = $wday == 2 || $wday == 4; // inainte de miercuri sau vineri
	$post = $wday == 3 || $wday == 5; // miercuri sau vineri
	$dupa = $wday == 4 || $wday == 6; // dupa miercuri sau vineri

	if( $mon == 7 && ($ajun && $mday == 30
					|| !$post && $mday == 31) )
	{
		$details->Ev_title = $ls->postMDls; // Lăsatul secului pentru Postul Adormirii Maicii Domnului
	}
	elseif( $post && $mon == 7 && $mday == 31
				|| !$dupa && $mon == 8 && $mday == 1 )
	{
		$details->Ev_title = $ls->postMDin; // Începutul Postului Adormirii Maicii Domnului
	}
	elseif( $mon == 11 && ($ajun && $mday == 13
						|| !$post && $mday == 14) )
	{
		$details->Ev_title = $ls->postNDls; // Lăsatul secului pentru Postul Crăciunului
	}
	elseif( $mon == 11 && ($post && $mday == 14 ||
								!$dupa && $mday == 15) )
	{
		$details->Ev_title = $ls->postNDin; // Începutul Postului Crăciunului
	}
}

function formatDate( $date )
{
    static $fmtDate = null;

    if (empty($fmtDate)) {
        $fmtDate = datefmt_create('ro_RO.UTF-8', 0, 0, null, null, 'EEEE, d MMMM y');
    }

	return datefmt_format($fmtDate, $date );
}

function getHolidayKey( $fileName )
{
	$prefix_len = strrpos( $fileName, "/" );
	if( $prefix_len !== FALSE )
	{
		$prefix_len++;
	}
	$pos = strrpos( $fileName, "_" );
	if( !$pos ) // No year variant
	{
		$pos = strrpos( $fileName, "." );
	}
	if( !$pos )
	{
		$pos = strlen( $fileName );
	}
	$key = substr( $fileName, $prefix_len, $pos - $prefix_len );
	return $key;
}

function getHolidayName( $name )
{
	if( strpos( $name, '.' ) )
	{
		$key = getHolidayKey( $name );
	}
	else
	{
		$key = $name;
	}
	if( is_numeric( $key ) )
	{
		$ikey = strval( intval( $key ) );
		if( strval( $key ) !== $ikey )
		{
			$vecernie = TRUE;
			$key = $ikey;
		}
	}
	$pos = strrpos( $name, '_' );
	if( $pos !== FALSE )
	{
		$year = substr( $name, $pos + 1, 4 );
	}
	$details = getDetails( $key );
	if( $details )
	{
		$name = getDayDetailsName( $details, FALSE, !empty( $vecernie) );
	}
	else
	{
		$name = $key; // Free text
	}
	if( !empty( $year) )
	{
		$name .= ' (' . $year . ')';
	}
	return $name;
}

function getDayDetailsName( $details, $onlyPrincipal = FALSE, $onlyEv_title = FALSE )
{
	$name = FALSE;
	$forcePrincipal = $onlyPrincipal && $onlyEv_title;
	if( $details )
	{
		if( !$onlyEv_title || $forcePrincipal )
		{
			$name = $details->getTitle();
			if( !$forcePrincipal &&
			( empty( $name ) && !$onlyPrincipal || !$details->isHoliday ) ) // Fara principal sau duminica
			{
				$subname = $details->subtitle;
				if( $subname )
				{
					if( $name )
					{
						$name .= " (";
						$compose = TRUE;
					}
					$name .= $subname;
					if( !empty( $compose))
					{
						$name .= ")";
					}
				}
			}
		}
		if( empty( $name ) )
		{
			$name = $details->Ev_title;
			$pos = strpos( $name, ';' );
			if( $pos )
			{
				if( $onlyEv_title )
				{
					$name = substr( $name, $pos + 2 );
				}
				else
				{
					$name = substr( $name, 0, $pos );
				}
			}
			elseif( $onlyPrincipal )
			{
				$name = FALSE;
			}
		}
	}
	return $name;
}

function compareHolidayKeys( $k1, $k2 )
{
	if( $k1 == $k2 )
	{
		return strlen( $k1 ) - strlen( $k2 ); // Vecernie dupa sarbatoare
	}
	$r1 = getHolidayRank( $k1 );
	$r2 = getHolidayRank( $k2 );
	if( $r1 != $r2 )
	{
		return $r1 - $r2;
	}
	if( $r1 == 0 ) // numeric?
	{
		return $k1 - $k2;
	}
	else
	{
		return strcmp( $k1, $k2 );
	}
}

function getHolidayRank( $key )
{
	if( is_numeric( $key ) )
	{
		return 0; // Easter-related
	}
	if( strpos( $key, " " ) === FALSE )
	{
		switch( $key ) // Special
		{
			case "bd1":
				return -2;

			case "bd2":
				return -1;

			case "sc1":
				return 1;

			case "sc2":
				return 2;

			case "nd1":
				return 3;

			case "nd2":
				return 4;
		}
	}
	if( strpos( $key, "-", 1 ) !== FALSE )
	{
		return 5; // Calendar-related
	}
	return 6; // Free text
}

function calcVoscrGlas( $zi, $details, $Easter = FALSE )
{
	$year = $zi["year"];
	if( !$Easter )
	{
		$Easter = getEasterDate( $year );
	}
	$EasterDay = $Easter["yday"];
	$day = $zi["yday"];
	if( $day < $EasterDay )
	{
		if( $EasterDay - $day <= 7 ) // Saptamana Mare
		{
			return;
		}
		$year--;
		$Easter = getEasterDate( $year );
		$EasterDay = $Easter["yday"] - 365;
		if( isLeap( $year ) )
		{
			$EasterDay--;
		}
	}
	$week = (int)(( $day - $EasterDay ) / 7);
	if( $week == 0 || $week == 7 ) // De Pasti si de Rusalii nu se citeste Ev. Invierii
	{
		return;
	}
	if( $zi["wday"] == 0 )
	{
		$Penticostar = array( 0, 1, 4, 5, 7, 8, 10, 0 );
		if( $week <= 7 )
		{
			$details->voscr = $Penticostar[ $week ];
		}
		else
		{
			$details->voscr = ( ( $week - 8 ) % 11 ) + 1;
		}
	}
	$details->glas = ( ( $week - 1 ) % 8) + 1;
}

function getMoonPhase(array $zi)
{
    static $PERIOD = 29.530587981;
    $days = ($zi[0] - 1481673900) / 86400; // 2016-12-14 00:05 = full moon (1)
    $months = $days / $PERIOD;
    $phase = $months - floor($months);

    return $phase;
}
?>