<?php
$dir = dirname(__FILE__);
require_once( "$dir/roman.php" );

class PericopaPart
{
	var $autor;
	var $capitol;
	var $verset_start;
	var $verset_end;
	var $carte;

	function load( $pericopa, $lastAutor, $lastCapitol )
	{
		$this->carte = $pericopa;
		$atoms = explode( " ", $pericopa );
		$n = count( $atoms );
		if( $n < 3 )
		{
			$this->autor = $lastAutor;
		}
		else
		{
			$autor = $atoms[$n - 3];
			$this->autor = strtolower( $autor );
			if( $n > 3 )
			{
				$this->autor .= RomanToArabic( $atoms[$n - 4] );
			}
		}
		if( $n < 2 )
		{
			$this->capitol = $lastCapitol;
		}
		else
		{
			$capitol = $atoms[$n - 2];
			$capitol = substr( $capitol, 0, strlen( $capitol ) - 1 );
			$this->capitol = RomanToArabic( $capitol );
		}
		$versete = $atoms[$n - 1];
		$versete = explode( "-", $versete );
		$this->verset_start = $versete[0];
		if( count( $versete ) < 2 )
		{
			$this->verset_end = $this->verset_start;
		}
		else
		{
			$this->verset_end = $versete[1];
		}
	}
}

class PericopaDetails
{
	var $parts;

	function  __construct( $pericopa )
	{
		$this->parts = array();
		$this->load( $pericopa );
	}

	function load( $pericopa )
	{
		$partsText = explode( "; ", $pericopa );
		$lastAutor = "";
		$lastCapitol = 0;
		$i = 0;
		foreach( $partsText as $partText )
		{
			$part = new PericopaPart;
			$part->load( $partText, $lastAutor, $lastCapitol );
			$lastAutor = $part->autor;
			$lastCapitol = $part->capitol;
			$this->parts[$i++] = $part;
		}
	}
}

function loadPericopa( $pericopa )
{
	return new PericopaDetails( $pericopa );
}
?>