<?php
require_once( "cod/sursaPericopa.php" );

class PericopaGolia extends SursaPericopa
{
	var $cache; // autor => html

	function PericopaGolia()
	{
		$this->url = "http://biblioteca.golia.ro/biblia/";
		$this->charset = "iso-8859-2";
		$this->nota = "Textul este preluat de pe site-ul <a target='_blank' href='http://www.golia.ro'>Mnstirii Golia</a>.";
		$this->cache = array();
	}

	function getChapter( $autor, $capitol )
	{
		$html = $this->cache[$autor];
		if( empty( $html ) )
		{
			$url = $this->url . $autor . ".html";
			$html = $this->download( $url );
			$this->cache[$autor] = $html;
		}
		$pos = $this->findChapter( $html, $capitol );
		if( $pos === FALSE )
		{
			return FALSE;
		}
		$end = $this->findChapter( $html, $capitol + 1, $pos + 1 );
		if( !$end )
		{
			$end = strlen( $html ); // last chapter
		}
		return substr( $html, $pos, $end - $pos );
	}

	function findChapter( $html, $capitol, $pos = 0 )
	{
		define( "CHAPTER", "CAPITOLUL" );

		$size = strlen( $html );
		do
		{
			$pos = strpos( $html, CHAPTER, $pos );
			if( $pos === FALSE )
			{
				echo "Nu este inceputul de capitol.";
				return FALSE;
			}
			$pos += strlen( CHAPTER );
			while( $pos < $size && !ctype_digit( $html[$pos++] ) );
			if( $pos == $size )
			{
				echo "Nu este numarul de capitol.";
				return FALSE;
			}
			$end = $pos;
			$pos--;
			while( $end < $size && ctype_digit( $html[$end++] ) );
			if( $end == $size )
			{
				echo "Nu este inceputul textului din capitol.";
				return FALSE;
			}
			$end--;
			$cap = substr( $html, $pos, $end - $pos );
			$cap = intval( $cap );
		} while( $cap < $capitol );
		if( $cap != $capitol )
		{
			return FALSE; // No such chapter. May be ok for the last one.
		}
		return $end;
	}
}
?>