<?php
require_once( "cod/sursaDate.php" );

class SinaxarCalendarOrtodox extends SursaDate
{
	var $completeURL;
	var $month;
	var $day;
    var $fmtMonth;
    var $fmtDay;

	function  __construct(  )
	{
		$this->url = "http://calendar-ortodox.ro/";
		$this->nota = "Textul este preluat de pe site-ul <a target='_blank' href='$this->url'>Calendar Ortodox</a>.";
        $this->fmtMonth = datefmt_create('ro_RO.UTF-8', 0, 0, null, null, 'MMMM');
        $this->fmtDay = datefmt_create('ro_RO.UTF-8', 0, 0, null, null, 'dd');
	}

	function setDate( $date ) // int
	{
		$this->month = strtolower( datefmt_format($this->fmtMonth, $date ) );
		$this->day = datefmt_format($this->fmtDay, $date );
		$this->completeURL = $this->url . "luna/$this->month/";
	}

	function getSinaxar(  )
	{
		$url = $this->completeURL . $this->month . $this->day . ".htm";
		return $this->downloadText( $url );
	}

	function getCompleteURL(  )
	{
		return $this->completeURL;
	}

	function parse( $html )
	{
		if( !$html )
		{
			return FALSE;
		}
		$pos = strpos( $html, "<table" );
		$pos = strpos( $html, "<table", $pos + 1 );
		$pos = strpos( $html, "<td", $pos );
		$pos = strpos( $html, "<td", $pos + 1 );
		$pos = strpos( $html, ">", $pos ) + 1;
		$end = strpos( $html, "</td>", $pos );
        if( $end){
		    while( $html[$end--] != "#" );
		    while( $html[$end--] != "/" );
		    $end = strpos( $html, ">", $end ) + 1;
        } else {
            $end = strlen( $html);
        }
		return substr( $html, $pos, $end - $pos );
	}
}
