<?php
$dir = dirname(__FILE__);
require_once( "$dir/sursaDate.php" );
require_once( "$dir/roman.php" );

class SursaPericopa extends SursaDate
{
	function getPericopa( $pericopa )
	{
		$text = "";
		$lastAutor = "";
		$lastCapitol = 0;
		foreach( $pericopa->parts as $part )
		{
			$html = $this->getChapter( $part->autor, $part->capitol );
			if( !$html )
			{
				return "<span class='eroare'>Nu este capitolul " . $part->capitol . " din " . $part->autor . "</span>";
			}
			if( $part->autor != $lastAutor )
			{
				$lastAutor = $part->autor;
				$lastCapitol = 0;
				$text .= "<span class='autor'>" . $part->carte . "</span>";
			}
			if( $part->capitol != $lastCapitol )
			{
				$lastCapitol = $part->capitol;
				$text .= "<span class='capitol'>Capitolul " . ArabicToRoman( $part->capitol ) . "</span>";
			}
			else
			{
				$text .= "<hr>";
			}
			$text .= $this->getVerset( $part, $html );
		}
		return $text;
	}

	function getVerset( $part, $html ) // PericopaDetails
	{
		if( empty( $html ) )
		{
			return FALSE;
		}
		$pos = strpos( $html, $part->verset_start . ". " );
		if( $pos === FALSE )
		{
			return "<span class='eroare'>Nu este versetul " . $part->verset_start . "</span>";
		}
		$end = strpos( $html, $part->verset_end . ". ", $pos );
		if( $end === FALSE )
		{
			return "<span class='eroare'>Nu este versetul " . $part->verset_end . "</span>";
		}
		$end = strpos( $html, "<", $end );
		if( $end === FALSE )
		{
			$end = strlen( $html );
		}
		$text = substr( $html, $pos, $end - $pos );
		return $text;
	}
}
?>